using namespace std;
#include <fstream>
#include <string.h>

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include "data.h"

#include "audio.h"
#include "input.h"
#include "logic.h"
#include "visuals.h"

extern Audio* audio;
extern Input* input;
extern Logic* logic;
extern Visuals* visuals;

//-------------------------------------------------------------------------------------------------
Data::Data(void)
{
    ClearHighScores();

//    PlayerWithHighestScore = 255;
    PlayerRankOnGameOver = 10;
    NameInputJoyCharX = 0;
    NameInputJoyCharY = 0;
    NameInputJoyChar = (char)NULL;
    NewHighScoreRegistered = false;

    CharReadIndexStart = 0;
    CharReadIndexEnd = 0;

    EndOfLineForWindows = "\r\n";
    EndOfLineForEverythingElse = "\n";

    #ifdef _WIN32
        EndOfLine = EndOfLineForWindows;
    #else
        EndOfLine = EndOfLineForEverythingElse;
    #endif
}

//-------------------------------------------------------------------------------------------------
Data::~Data(void)
{

}

//-------------------------------------------------------------------------------------------------
void Data::CheckForNewHighScore(void)
{
int playerRank = 10;

    for (int rank = 0; rank < 10; rank++)
    {
        if (logic->Score >= HighScoresScore[logic->GameMode][rank])
        {
            playerRank = rank;

            for (int index = 9; index > rank; index--)
            {
                strcpy(HighScoresName[logic->GameMode][index], HighScoresName[logic->GameMode][index-1]);
                HighScoresLevel[logic->GameMode][index] = HighScoresLevel[logic->GameMode][index-1];
                HighScoresScore[logic->GameMode][index] = HighScoresScore[logic->GameMode][index-1];
            }

            char erase[20];
            for (int letter = 0; letter < 20; letter++)  erase[letter] = '\0';
            for (int letterTwo = 0; letterTwo < 20; letterTwo++)  HighScoresName[logic->GameMode][rank][letterTwo] = '\0';
            strcpy(HighScoresName[logic->GameMode][rank], erase);

            HighScoresLevel[logic->GameMode][rank] = (Uint8)logic->Level;
            HighScoresScore[logic->GameMode][rank] = logic->Score;

            rank = 10;
        }
    }

    HighScoresName[logic->GameMode][playerRank][0] = '\0';
	NameInputArayIndex = 0;

    PlayerRankOnGameOver = playerRank;

    NameInputJoyCharX = 0;
    NameInputJoyCharY = 0;
    NameInputJoyChar = 'A';
}

//-------------------------------------------------------------------------------------------------
void Data::ClearHighScores(void)
{
char name1st[19]  = { 'J', 'e', 'Z', 'x', 'L', 'e', 'e', '\0' };
char name2nd[19]  = { 'D', 'a', 'o', 't', 'h', 'e', 'm', 'a', 'n', '\0' };
char name3rd[19]  = { 'm', 'a', 't', 't', 'm', 'a', 't', 't', 'e', 'h', '\0' };
char name4th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name5th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name6th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name7th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name8th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name9th[19]  = { 'Y', 'o', 'u', '!', '\0' };
char name10th[19] = { 'Y', 'o', 'u', '!', '\0' };

    for (int gameMode = 0; gameMode < 5; gameMode++)
        for (int index = 0; index < 10; index++)
            for (int indexTwo = 0; indexTwo < 20; indexTwo++)
                HighScoresName[gameMode][index][indexTwo] = (char)NULL;

    for (int gameMode = 0; gameMode < 5; gameMode++)
    {
        for (int loop = 0; loop < 10; loop++)
        {
            switch (loop)
            {
                case 0:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name1st[index];

                    HighScoresLevel[gameMode][loop] = 10;
                    HighScoresScore[gameMode][loop] = 10000;
                    break;

                case 1:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name2nd[index];

                    HighScoresLevel[gameMode][loop] = 9;
                    HighScoresScore[gameMode][loop] = 9000;
                    break;

                case 2:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name3rd[index];

                    HighScoresLevel[gameMode][loop] = 8;
                    HighScoresScore[gameMode][loop] = 8000;
                    break;

                case 3:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name4th[index];

                    HighScoresLevel[gameMode][loop] = 7;
                    HighScoresScore[gameMode][loop] = 7000;
                    break;

                case 4:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name5th[index];

                    HighScoresLevel[gameMode][loop] = 6;
                    HighScoresScore[gameMode][loop] = 6000;
                    break;

                case 5:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name6th[index];

                    HighScoresLevel[gameMode][loop] = 5;
                    HighScoresScore[gameMode][loop] = 5000;
                    break;

                case 6:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name7th[index];

                    HighScoresLevel[gameMode][loop] = 4;
                    HighScoresScore[gameMode][loop] = 4000;
                    break;

                case 7:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name8th[index];

                    HighScoresLevel[gameMode][loop] = 3;
                    HighScoresScore[gameMode][loop] = 3000;
                    break;

                case 8:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name9th[index];

                    HighScoresLevel[gameMode][loop] = 2;
                    HighScoresScore[gameMode][loop] = 2000;
                    break;

                case 9:
                    for (int index = 0; index < 20; index++)
                        HighScoresName[gameMode][loop][index] = name10th[index];

                    HighScoresLevel[gameMode][loop] = 1;
                    HighScoresScore[gameMode][loop] = 1000;
                    break;

                default:
                    break;
            }
        }
    }
}

//-------------------------------------------------------------------------------------------------
void Data::SetupCurrentLineReadFromFile(void)
{
int arrayIndex = CharReadIndexEnd;

    if (CharReadIndexStart == 0)
    {
        while (CharRead[arrayIndex] == '')  arrayIndex++;
        CharReadIndexStart = arrayIndex;
        arrayIndex++;
    }
    else
    {
        while (CharRead[arrayIndex] != '')  arrayIndex++;
        CharReadIndexStart = (arrayIndex + 1);
        arrayIndex++;
    }

    while (CharRead[arrayIndex] != '')  arrayIndex++;
    CharReadIndexEnd = arrayIndex;

    for (int index = 0; index < 256; index++)  TextBuffer[index] = (char)NULL;

    arrayIndex = 0;
    for ( int index = CharReadIndexStart; index < (CharReadIndexEnd); index++)
    {
        TextBuffer[arrayIndex] = CharRead[index];
        arrayIndex++;
    }
}

//-------------------------------------------------------------------------------------------------
void Data::LoadHighScoresAndOptions(void)
{
char filename[1024];
char *base_path = SDL_GetPrefPath("16BitSoftInc", "LettersFall-Retail");
char *pref_path = NULL;

    if (base_path)
    {
        pref_path = SDL_strdup(base_path);
        SDL_free(base_path);
    }
    else  return;

	strcpy(filename, pref_path);
	strcat(filename, "LettersFall-5-Beta1-Data");

    SDL_RWops *fileToRead = SDL_RWFromFile(filename, "r");
    if (fileToRead != NULL)
    {
        SDL_RWread( fileToRead, CharRead, sizeof(char), 4999 );

        SetupCurrentLineReadFromFile();
        audio->MusicVolume = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        audio->SoundVolume = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
		visuals->FullScreenMode = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
		logic->GameMode = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
		logic->SelectedBackground = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
		logic->SelectedMusicTrack = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
		logic->MusicJukebox = atoi(TextBuffer) > 0;

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyButtonOne = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyButtonTwo = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyUP = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyRIGHT = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyDOWN = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyLEFT = (int)atoi(TextBuffer);

        SetupCurrentLineReadFromFile();
        input->UserDefinedKeyPause = (int)atoi(TextBuffer);

        for (int index = 0; index < 3; index++)
        {
            SetupCurrentLineReadFromFile();
            input->JoyUP[index] = (int)atoi(TextBuffer);

            SetupCurrentLineReadFromFile();
            input->JoyDOWN[index] = (int)atoi(TextBuffer);

            SetupCurrentLineReadFromFile();
            input->JoyLEFT[index] = (int)atoi(TextBuffer);

            SetupCurrentLineReadFromFile();
            input->JoyRIGHT[index] = (int)atoi(TextBuffer);

            SetupCurrentLineReadFromFile();
            input->JoyButton1[index] = (int)atoi(TextBuffer);

            SetupCurrentLineReadFromFile();
            input->JoyButton2[index] = (int)atoi(TextBuffer);
        }

        for (int gameMode = 0; gameMode < 5; gameMode++)
        {
            for (Uint8 rank = 0; rank < 10; rank++)
            {
                for (int nameIndex = 0; nameIndex < 18; nameIndex++)
                {
                    HighScoresName[gameMode][rank][nameIndex] = char(NULL);
                }

                SetupCurrentLineReadFromFile();

                for (Uint8 nameIndex = 0; nameIndex < 18; nameIndex++)
                {
                    if ( (TextBuffer[nameIndex] != '\r') && (TextBuffer[nameIndex] != '\n') )
                        HighScoresName[gameMode][rank][nameIndex] = TextBuffer[nameIndex];
                }

                SetupCurrentLineReadFromFile();
                HighScoresLevel[gameMode][rank] = atoi(TextBuffer);

                SetupCurrentLineReadFromFile();
                HighScoresScore[gameMode][rank] = atoi(TextBuffer);
            }
        }

        SDL_RWclose(fileToRead);
    }
}

//-------------------------------------------------------------------------------------------------
void Data::TryToSaveDataLine(SDL_RWops *file, const char *dataLine)
{
    if (  SDL_RWwrite( file, "", 1, 1 ) != 1  )
    {
        printf("Couldn't fully write string\n");
    }

    if (  SDL_RWwrite( file, dataLine, 1, SDL_strlen(dataLine) ) != SDL_strlen(dataLine)  )
    {
        printf("Couldn't fully write string\n");
    }

    if (  SDL_RWwrite( file, EndOfLine, 1, SDL_strlen(EndOfLine) ) != SDL_strlen(EndOfLine)  )
    {
        printf("Couldn't fully write string\n");
    }

    NumberOfCharsSaved+=( 1+ SDL_strlen(dataLine) + 1 + SDL_strlen(EndOfLine) );
}

//-------------------------------------------------------------------------------------------------
void Data::SaveHighScoresAndOptions(void)
{
char filename[1024];
char textBuffer[50];
char *base_path = SDL_GetPrefPath("16BitSoftInc", "LettersFall-Retail");
char *pref_path = NULL;

    if (base_path)
    {
        pref_path = SDL_strdup(base_path);
        SDL_free(base_path);
    }
    else  return;

	strcpy(filename, pref_path);
	strcat(filename, "LettersFall-5-Beta1-Data");

    SDL_RWops *fileToWrite = SDL_RWFromFile(filename, "w");
    if (fileToWrite != NULL)
    {
        NumberOfCharsSaved = 0;

        sprintf(textBuffer, "%d", audio->MusicVolume);
        TryToSaveDataLine(fileToWrite, textBuffer);

        sprintf(textBuffer, "%d", audio->SoundVolume);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", visuals->FullScreenMode);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", logic->GameMode);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", logic->SelectedBackground);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", logic->SelectedMusicTrack);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", logic->MusicJukebox);
        TryToSaveDataLine(fileToWrite, textBuffer);

    	sprintf(textBuffer, "%d", input->UserDefinedKeyButtonOne);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyButtonTwo);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyUP);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyRIGHT);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyDOWN);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyLEFT);
        TryToSaveDataLine(fileToWrite, textBuffer);

		sprintf(textBuffer, "%d", input->UserDefinedKeyPause);
        TryToSaveDataLine(fileToWrite, textBuffer);

        for (int index = 0; index < 3; index++)
        {
            sprintf(textBuffer, "%d", input->JoyUP[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);

            sprintf(textBuffer, "%d", input->JoyDOWN[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);

            sprintf(textBuffer, "%d", input->JoyLEFT[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);

            sprintf(textBuffer, "%d", input->JoyRIGHT[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);

            sprintf(textBuffer, "%d", input->JoyButton1[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);

            sprintf(textBuffer, "%d", input->JoyButton2[index]);
            TryToSaveDataLine(fileToWrite, textBuffer);
        }

        for (int gameMode = 0; gameMode < 5; gameMode++)
        {
            for (Uint8 rank = 0; rank < 10; rank++)
            {
                strcpy(textBuffer, HighScoresName[gameMode][rank]);
                TryToSaveDataLine(fileToWrite, textBuffer);

                sprintf(textBuffer, "%d", HighScoresLevel[gameMode][rank]);
                TryToSaveDataLine(fileToWrite, textBuffer);

                sprintf(textBuffer, "%d", HighScoresScore[gameMode][rank]);
                TryToSaveDataLine(fileToWrite, textBuffer);
            }
        }

        if (NumberOfCharsSaved < 5000)
        {
            for ( int index = 0; index < (5000-NumberOfCharsSaved); index++)
            {
                if (  SDL_RWwrite( fileToWrite, "", 1, 1 ) != 1  )
                {
                    printf("Couldn't fully write string\n");
                }
                NumberOfCharsSaved++;
            }
        }
    }

    SDL_RWclose(fileToWrite);
}
//-------------------------------------------------------------------------------------------------
