#ifndef INTERFACE
#define INTERFACE

class Interface
{
public:

	Interface(void);
	virtual ~Interface(void);

    #define NumberOfButtons     7
    struct ButtonGUI
    {
        Uint16 SpriteIndex;
        Sint8 ScreenIndex;
        float Scale;
        int ScreenY;
        Sint16 AnimationTimer;
    } ButtonGUIs[NumberOfButtons];

    Uint8 ButtonSelectedByKeyboard;
    Uint8 ButtonSelectedByPlayer;

    #define NumberOfArrowSets     10
    struct ArrowSetGUI
    {
        float LeftArrowScreenIndex;
        float LeftArrowScale;
        float RightArrowScale;
        int ScreenY;
        Sint16 AnimationTimer;
    } ArrowSetGUIs[NumberOfArrowSets];

    Uint8 ArrowSetSelectedByKeyboard;
    float ArrowSetArrowSelectedByPlayer;

    void CreateButton(Uint16 SpriteIndex, Uint8 ScreenIndex, int ScreenY);
    void DisplayAllButtonsOntoScreenBuffer(void);
    void ProcessAllButtons(void);
    void DestroyAllButtons(void);

    void CreateArrowSet(float ScreenIndex, int ScreenY);
    void DisplayAllArrowSetsOntoScreenBuffer(void);
    void ProcessAllArrowSets(void);
    void DestroyAllArrowSets(void);
};

#endif
