#ifndef LOGIC
#define LOGIC

class Logic
{
public:

	Logic(void);
	virtual ~Logic(void);

    #define ChildMode                   0
    #define TeenagerMode                1
    #define AdultMode                   2
    #define TimeAttack15MinuteMode      3
    #define StoryMode                   4
    Uint8 GameMode;

    Uint8 SelectedBackground;
    Uint8 SelectedMusicTrack;

    bool MusicJukebox;

    bool Shareware;

    bool PAUSEgame;

    int GameOver;

    #define NumberOfLetters     26

    Uint32 Score;
    Uint16 Level;
    Uint16 Bombs;

    Uint8 Playfield[11][18];

    Uint8 NextLetters[3];
    Uint8 FallingLetters[3];

    int FallingLettersPlayfieldX[3];
    int FallingLettersPlayfieldY[3];
    int FallingLettersScreenX[3];
    int FallingLettersScreenY[3];
    int FallingLettersOffsetY;
    Uint8 FallingLettersNextPlayfieldX;

    float DownArrowScale;
    int DownArrowPressedTimer;
    float LeftArrowScale;
    int LeftArrowPressedTimer;
    float RightArrowScale;
    int RightArrowPressedTimer;

    bool DroppingFast;

    int BombButtonPressedTimer;
    float BombButtonScale;
    float ExplosionScale;
    Uint8 ExplosionTransparency;

    int SelectedLetterPlayfieldX[11];
    int SelectedLetterPlayfieldY[11];

    float ClearButtonScale;
    int ClearButtonPressedTimer;
    float UndoButtonScale;
    int UndoButtonPressedTimer;

    float CheckButtonScale;
    int CheckButtonPressedTimer;
    Uint8 CheckButtonRedHue;
    Uint8 CheckButtonGreenHue;
    Uint8 CheckButtonBlueHue;

    Uint8 ClearWordTransparency;

    int BombBonusMeterValue;
    int LevelAdvancementValue;

    int DrawEntirePlayingGameScreen;

    Uint32 InitialGameSpeed[5];
    Uint32 CurrentGameSpeed;

    Uint32 TimeAttackMinutes;
    Uint32 TimeAttackSeconds;
    Uint32 TimeAttackNextSecondTick;

    Uint8 GetRandomLetter(void);

    void SetupNextLetters(void);

    void SetupForNewGame(void);

    void DeleteLettersInPlayfieldFromExplosion(void);

    bool ApplyGravityToPlayfield(void);

    bool CheckSelectedLettersForWord(void);

    void ClearSelectedLetters(void);
    void ClearSelectedLettersInPlayfield(void);

    void RunGameplayEngine(void);
};

#endif
