#ifndef SCREENS
#define SCREENS

class Screens
{
public:

	Screens(void);
	virtual ~Screens(void);

    Uint8 ScreenFadeTransparency;
    #define FadeIn          0
    #define FadeNone        1
    #define FadeOut         2
    #define FadeAll         3
    Uint8 ScreenTransitionStatus;
    Uint32 ScreenDisplayTimer;

    #define SixteenBitSoftScreen			0
    #define TitleScreen						1
    #define OptionsScreen					2
    #define HowToPlayScreen					3
    #define HighScoresScreen				4
    #define AboutScreen						5
    #define NewGameOptionsScreen			6
    #define PlayingGameScreen				7
    #define NameInputMouseKeyboardScreen    8
    int ScreenToDisplay;
    int ScreenIsDirty;

	struct NameInputButton
	{
		int ScreenX;
		int ScreenY;
		float Scale;
		int ScaleTimer;
	} NameInputButtons[73];

    void ApplyScreenFadeTransition(void);

    void DisplaySelectedBackround(void);

    void ProcessScreenToDisplay(void);
    void DisplaySixteenBitSoftScreen(void);
    void DisplayTitleScreen(void);

    void DisplayOptionsScreen(void);

    void DisplayHowToPlayScreen(void);

    void DisplayHighScoresScreen(void);

    void DisplayAboutScreen(void);

    void DisplayPlayingGameScreen(void);

	void DisplayNameInputMouseKeyboardScreen(void);

};

#endif
